/* 
 * Copyright (C) 2000 the xine project
 * 
 * This file is part of xine, a unix video player.
 * 
 * xine is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * xine is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 * $Id: audio_out.h,v 1.7 2000/12/11 09:50:43 f1rmb Exp $
 */
#ifndef HAVE_AUDIO_OUT_H
#define HAVE_AUDIO_OUT_H

#include <inttypes.h>
#include "audio_out_t.h"
#include "audio_oss_out.h"
#include "audio_null_out.h"

#ifdef HAVE_ALSA
#include "audio_alsa_out.h"
#endif

#define AO_UNSET -1
#define AO_OSS    0
#define AO_NULL   1
#if defined(HAVE_ALSA)
#define AO_ALSA   2
#endif

/*
 * find right device driver, init it
 */
ao_functions_t *audio_out_init(int) ;

#endif


