/* 
 * Copyright (C) 2000 the xine project
 * 
 * This file is part of xine, a unix video player.
 * 
 * xine is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * xine is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 * $Id: gui_widget.h,v 1.4 2000/12/10 02:07:57 f1rmb Exp $
 *
 */

#ifndef HAVE_WIDGET_H
#define HAVE_WIDGET_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "monitor.h"
#include "gui_widget_types.h"

#define FOCUS_RECEIVED 1
#define FOCUS_LOST     0
#define LBUTTON_DOWN   0
#define LBUTTON_UP     1

typedef struct widget_s {
  int      x,y;
  int      width,height;

  void (*paint) (struct widget_s *,  Window, GC) ; 
  
  /* notify callback return value : 1 => repaint necessary 0=> do nothing */
  int (*notify_click) (struct widget_s *,int,int,int); /* parameter: up (1) or down (0)   */
  int (*notify_focus) (struct widget_s *,int); /*            entered (1) left (0) */
 
  void    *private_data;
  int      widget_type;
} widget_t;

typedef struct widget_list_s {
  struct gui_list_s *l ;

  widget_t          *focusedWidget ;
  widget_t          *pressedWidget ;

  Window             win;
  GC                 gc;
} widget_list_t;

void paint_widget_list (widget_list_t *wl) ;

int is_inside_widget (widget_t *widget, int x, int y) ;

widget_t *get_widget_at (widget_list_t *wl, int x, int y) ;

void motion_notify_widget_list (widget_list_t *wl, int x, int y) ;

int click_notify_widget_list (widget_list_t *wl, int x, int y, int bUp) ;

#endif
